
package de.ivu.elect.business.wahlbeteiligung.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlauf;

@RequestScoped
@Named(WahlbeteiligungVerlaufConversationSelect.COMPONENT_NAME)
public class WahlbeteiligungVerlaufConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlbeteiligungVerlaufConversationSelect";

  @Inject
  protected transient WahlbeteiligungVerlaufExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(WahlbeteiligungVerlaufConversationStore.class)
  protected transient WahlbeteiligungVerlaufConversationStore conversationStore;

  public WahlbeteiligungVerlaufConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public WahlbeteiligungVerlauf getEntity() {
    return getEntityInternal();
  }

  private WahlbeteiligungVerlauf getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(WahlbeteiligungVerlauf entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(WahlbeteiligungVerlauf entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected WahlbeteiligungVerlauf attach(WahlbeteiligungVerlauf entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected WahlbeteiligungVerlauf attach( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
